/**
 * @author Ramkumar Alagappan
 * Created on Jan 10, 2004

Description :

	This Program is a SOAP Client. The name entered by the client will be send to the SOAP Service Method "usr_firstMethod" which will return the same name and this will be printed in the client DOS Prompt.


SOAP Client Name 		: TestSampleService 

Runtime Input Details : args[] - 1 command line argument

*/


import java.io.*;
import java.util.*;
import java.net.*;
import org.w3c.dom.*;
import org.apache.soap.util.xml.*;
import org.apache.soap.*;
import org.apache.soap.encoding.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;


public class TestSampleService
{

public static void main(String [] a)throws Exception
{

//a[0] - Any Name.

	Call call=null;
	Vector vector=null;
	Response response=null;
	Parameter parameter=null;
	Object object=null;
	Fault fault=null;

	call=new Call();

	call.setTargetObjectURI("urn:Sample");
	call.setMethodName("usr_firstMethod");
	call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);

	vector=new Vector();
	vector.addElement(new Parameter("value", String.class, a[0], null));
	call.setParams(vector);
	System.out.println("Vector Contains : \n"+vector+"\n");
	
	try{
	response=call.invoke(new URL("http://localhost:8080/soap/servlet/rpcrouter"), "");
	System.out.println("Response : \n"+response+"\n");
	}catch(SOAPException e1)
		{
		System.out.println("SOAP Exception was Caught : ");
		System.err.println("Fault code is : "+e1.getFaultCode()+"\n");
		System.err.println("Fault String is : "+e1.getMessage()+"\n");
		return;
		}
	catch(Exception e2)
		{
		System.out.println("Exception was Caught : "+e2);
		return;
		}
	
	if(!response.generatedFault())
	{
	parameter=response.getReturnValue();
	object=parameter.getValue();
	System.out.println("The Given String is : \""+object+"\".");
	}

	else
	{
	fault=response.getFault();
	System.err.println("Generated Fault : ");
	System.err.println("Fault Code : "+fault.getFaultCode());
	System.err.println("Fault String : "+fault.getFaultString());
	}
}
}
